<?php if (!defined('PmWiki')) exit();

/*
 swfGallery,  PmWiki swfGallery markup
*/

$RecipeInfo['swfGallery']['Version']='2008-05-19';

$ActionSkin['swfgallery'] = 'swfgallery';

SDV($SwfGalleryObjUrl, $ScriptUrl."/wiki/cookbook/swfgallery/viewer.swf");
SDV($SwfGalleryJsUrl, $ScriptUrl."/wiki/cookbook/swfgallery/swfobject.js");
SDV($SwfGalleryXmlUrl, $ScriptUrl."/mkgallery.php");

SDV($SwfGalleryBGcolor,''); ## the bg-color property
SDV($SwfGalleryTitle,'');   ## the title property
SDV($SwfGalleryNavPos,'');
SDV($SwfGalleryThumbCols,'');
SDV($SwfGalleryThumbRows,'');

$HTMLHeaderFmt['swfgallery'] =
'<script type="text/javascript" src="'.$SwfGalleryJsUrl.'"></script>';
    


Markup('SwfGallery', 'inline','/\\(:swfgallery\s*(.*?)\s*:\\)/e', "ShowSwfGallery('$1')");

function ShowSwfGallery($args){
  global $IsJsEnabled, $pagename, $FarmD, $ScriptUrl;
  global $SwfGalleryBGcolor, $SwfGalleryTitle, $SwfGalleryNavPos;
  global $SwfGalleryObjUrl, $SwfGalleryJsUrl, $SwfGalleryXmlUrl;

  SDV($IsJsEnabled,1);
  if (!$IsJsEnabled) return '';

  $args = ParseArgs($args); 

  $width=getArg($args,array('width','w'),"100%");
  if (strlen($width)<1)$width="100%";

  $height=getArg($args,array('height','h'),"600");
  if (strlen($height)<1)$height="600";

  $bg=getArg($args,array('bg','background'),$SwfGalleryBGcolor);  

  $xmlfile=getArg($args,array('xmlfile'),'');

  
  $title=getArg($args,array('title'),$SwfGalleryTitle);

  $navpos=getArg($args,array('navpos'),$SwfGalleryNavPos);
  if (strlen($navpos)<1)$navpos="bottom";
  
  $cols=getArg($args,array('columns','cols'),$SwfGalleryThumbCols);
  if (strlen($cols)<1)$cols="6";  

  $rows=getArg($args,array('rows'),$SwfGalleryThumRows);
  if (strlen($rows)<1)$rows="2";  


  $iurl=getArg($args,array('imagespath'),'');
  $thurl=getArg($args,array('thumbspath'),'');  

  if (empty($xmlfile)) {
    $path=getArg($args,array('path'),'');
    if (strlen($path)<1) return '';
  
    $url=getArg($args,array('url'),'');
    if (strlen($url)<1) return '';

    $xml = $SwfGalleryXmlUrl . "?path=".$FarmD."/$path&url=$url&";
  } else {
    $xml = $xmlfile . "?";
  }
  
  $xml .= "cols=$cols&rows=$rows";
  $xml .= "&navpos=$navpos&iurl=$iurl&thurl=$thurl";

  return  Keep("<div id=\"flashcontent\" style=\"width: 100%; height: 100%; z-order: 0;\">
  <a href=\"http://www.macromedia.com/go/getflashplayer\">Get the Flash Player</a> to view the gallery.</div>
  <script type=\"text/javascript\">
  var so = new SWFObject(\"".$SwfGalleryObjUrl."\", \"viewer\", \"$width\","
  ." \"$height\", \"7\", \"$bg\");
  so.addVariable(\"preloaderColor\",\"0x999999\");
  so.addVariable(\"xmlDataPath\", \"$xml\");
  so.write(\"flashcontent\");
  </script>\n");
  
  /*
  so.addVariable(\"thumbnailColumns\",\"$cols\");
  so.addVariable(\"thumbnailRows\",\"$rows\");  
  so.addVariable(\"navPosition\",\"$navpos\");
  so.addVariable(\"title\",\"$title\");  
  */
}

#-------------------------------------------------------------------------------
if (!function_exists("getArg")){
  function getArg($args,$names,$default=null){
    if (is_string($names)){
      if (isset($args[$names])) return $args[$names];
      return $default;
    }
    if (is_array($names)){foreach($names as $n){if (isset($args[$n])) return $args[$n];}}
    return $default;
  }
 }

